/*
Copyright 2019 Rancher Labs.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by main. DO NOT EDIT.

package v1

import (
	v1 "github.com/rancher/rio/pkg/apis/admin.rio.cattle.io/v1"
	"github.com/rancher/rio/pkg/generated/clientset/versioned/scheme"
	rest "k8s.io/client-go/rest"
)

type AdminV1Interface interface {
	RESTClient() rest.Interface
	ClusterDomainsGetter
	PublicDomainsGetter
	RioInfosGetter
	SystemStacksGetter
}

// AdminV1Client is used to interact with features provided by the admin.rio.cattle.io group.
type AdminV1Client struct {
	restClient rest.Interface
}

func (c *AdminV1Client) ClusterDomains() ClusterDomainInterface {
	return newClusterDomains(c)
}

func (c *AdminV1Client) PublicDomains() PublicDomainInterface {
	return newPublicDomains(c)
}

func (c *AdminV1Client) RioInfos() RioInfoInterface {
	return newRioInfos(c)
}

func (c *AdminV1Client) SystemStacks() SystemStackInterface {
	return newSystemStacks(c)
}

// NewForConfig creates a new AdminV1Client for the given config.
func NewForConfig(c *rest.Config) (*AdminV1Client, error) {
	config := *c
	if err := setConfigDefaults(&config); err != nil {
		return nil, err
	}
	client, err := rest.RESTClientFor(&config)
	if err != nil {
		return nil, err
	}
	return &AdminV1Client{client}, nil
}

// NewForConfigOrDie creates a new AdminV1Client for the given config and
// panics if there is an error in the config.
func NewForConfigOrDie(c *rest.Config) *AdminV1Client {
	client, err := NewForConfig(c)
	if err != nil {
		panic(err)
	}
	return client
}

// New creates a new AdminV1Client for the given RESTClient.
func New(c rest.Interface) *AdminV1Client {
	return &AdminV1Client{c}
}

func setConfigDefaults(config *rest.Config) error {
	gv := v1.SchemeGroupVersion
	config.GroupVersion = &gv
	config.APIPath = "/apis"
	config.NegotiatedSerializer = scheme.Codecs.WithoutConversion()

	if config.UserAgent == "" {
		config.UserAgent = rest.DefaultKubernetesUserAgent()
	}

	return nil
}

// RESTClient returns a RESTClient that is used to communicate
// with API server by this client implementation.
func (c *AdminV1Client) RESTClient() rest.Interface {
	if c == nil {
		return nil
	}
	return c.restClient
}
