// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: github.com/solo-io/gloo/projects/gateway/api/v1/route_table.proto

package v1

import (
	bytes "bytes"
	fmt "fmt"
	math "math"

	_ "github.com/gogo/protobuf/gogoproto"
	proto "github.com/gogo/protobuf/proto"
	core "github.com/solo-io/solo-kit/pkg/api/v1/resources/core"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.GoGoProtoPackageIsVersion3 // please upgrade the proto package

//
//
// The **RouteTable** is a child Routing object for the Gloo Gateway.
//
// A **RouteTable** gets built into the complete routing configuration
// when it is referenced by a `delegateAction`, either
// in a parent VirtualService or another RouteTable.
//
// Routes specified in a RouteTable must have their paths start with the prefix provided in the
// parent's matcher.
//
// For example, the following configuration:
//
//
// ```
// virtualService: mydomain.com
// match: /a
// delegate: a-routes
// ---
// routeTable: a-routes
// match: /1
//
// ```
//
// would *not be valid*, while
//
// ```
// virtualService: mydomain.com
// match: /a
// delegate: a-routes
// ---
// routeTable: a-routes
// match: /a/1
//
// ```
//
// *would* be valid.
//
//
// A complete configuration might look as follows:
//
// ```yaml
// apiVersion: gateway.solo.io/v1
// kind: VirtualService
// metadata:
//   name: 'any'
//   namespace: 'any'
// spec:
//   virtualHost:
//     domains:
//     - 'any.com'
//     routes:
//     - matcher:
//         prefix: '/a' # delegate ownership of routes for `any.com/a`
//       delegateAction:
//         name: 'a-routes'
//         namespace: 'a'
//     - matcher:
//         prefix: '/b' # delegate ownership of routes for `any.com/b`
//       delegateAction:
//         name: 'b-routes'
//         namespace: 'b'
// ```
//
// * A root-level **VirtualService** which delegates routing to to the `a-routes` and `b-routes` **RouteTables**.
// * Routes with `delegateActions` can only use a `prefix` matcher.
//
// ```yaml
// apiVersion: gateway.solo.io/v1
// kind: RouteTable
// metadata:
//   name: 'a-routes'
//   namespace: 'a'
// spec:
//   routes:
//     - matcher:
//         # the path matchers in this RouteTable must begin with the prefix `/a/`
//         prefix: '/a/1'
//       routeAction:
//         single:
//           upstream:
//             name: 'foo-upstream'
//
//     - matcher:
//         prefix: '/a/2'
//       routeAction:
//         single:
//           upstream:
//             name: 'bar-upstream'
// ```
//
// * A **RouteTable** which defines two routes.
//
// ```yaml
// apiVersion: gateway.solo.io/v1
// kind: RouteTable
// metadata:
//   name: 'b-routes'
//   namespace: 'b'
// spec:
//   routes:
//     - matcher:
//         # the path matchers in this RouteTable must begin with the prefix `/b/`
//         regex: '/b/3'
//       routeAction:
//         single:
//           upstream:
//             name: 'bar-upstream'
//     - matcher:
//         prefix: '/b/c/'
//       # routes in the RouteTable can perform any action, including a delegateAction
//       delegateAction:
//         name: 'c-routes'
//         namespace: 'c'
//
// ```
//
// * A **RouteTable** which both *defines a route* and *delegates to* another **RouteTable**.
//
//
// ```yaml
// apiVersion: gateway.solo.io/v1
// kind: RouteTable
// metadata:
//   name: 'c-routes'
//   namespace: 'c'
// spec:
//   routes:
//     - matcher:
//         exact: '/b/c/4'
//       routeAction:
//         single:
//           upstream:
//             name: 'qux-upstream'
// ```
//
// * A RouteTable which is a child of another route table.
//
//
// Would produce the following route config for `mydomain.com`:
//
// ```
// /a/1 -> foo-upstream
// /a/2 -> bar-upstream
// /b/3 -> baz-upstream
// /b/c/4 -> qux-upstream
// ```
//
type RouteTable struct {
	// the list of routes for the route table
	Routes []*Route `protobuf:"bytes,1,rep,name=routes,proto3" json:"routes,omitempty"`
	// Status indicates the validation status of this resource.
	// Status is read-only by clients, and set by gloo during validation
	Status core.Status `protobuf:"bytes,6,opt,name=status,proto3" json:"status" testdiff:"ignore"`
	// Metadata contains the object metadata for this resource
	Metadata             core.Metadata `protobuf:"bytes,7,opt,name=metadata,proto3" json:"metadata"`
	XXX_NoUnkeyedLiteral struct{}      `json:"-"`
	XXX_unrecognized     []byte        `json:"-"`
	XXX_sizecache        int32         `json:"-"`
}

func (m *RouteTable) Reset()         { *m = RouteTable{} }
func (m *RouteTable) String() string { return proto.CompactTextString(m) }
func (*RouteTable) ProtoMessage()    {}
func (*RouteTable) Descriptor() ([]byte, []int) {
	return fileDescriptor_4d1ea5a66e7f9a13, []int{0}
}
func (m *RouteTable) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_RouteTable.Unmarshal(m, b)
}
func (m *RouteTable) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_RouteTable.Marshal(b, m, deterministic)
}
func (m *RouteTable) XXX_Merge(src proto.Message) {
	xxx_messageInfo_RouteTable.Merge(m, src)
}
func (m *RouteTable) XXX_Size() int {
	return xxx_messageInfo_RouteTable.Size(m)
}
func (m *RouteTable) XXX_DiscardUnknown() {
	xxx_messageInfo_RouteTable.DiscardUnknown(m)
}

var xxx_messageInfo_RouteTable proto.InternalMessageInfo

func (m *RouteTable) GetRoutes() []*Route {
	if m != nil {
		return m.Routes
	}
	return nil
}

func (m *RouteTable) GetStatus() core.Status {
	if m != nil {
		return m.Status
	}
	return core.Status{}
}

func (m *RouteTable) GetMetadata() core.Metadata {
	if m != nil {
		return m.Metadata
	}
	return core.Metadata{}
}

func init() {
	proto.RegisterType((*RouteTable)(nil), "gateway.solo.io.RouteTable")
}

func init() {
	proto.RegisterFile("github.com/solo-io/gloo/projects/gateway/api/v1/route_table.proto", fileDescriptor_4d1ea5a66e7f9a13)
}

var fileDescriptor_4d1ea5a66e7f9a13 = []byte{
	// 322 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x94, 0x91, 0xb1, 0x4e, 0x02, 0x31,
	0x18, 0xc7, 0x3d, 0xbd, 0x9c, 0xa6, 0x18, 0x8d, 0x17, 0x42, 0x90, 0x41, 0x08, 0x13, 0x8b, 0x6d,
	0x80, 0x45, 0xd9, 0x24, 0x31, 0x4e, 0x2e, 0xa7, 0x93, 0x0b, 0x29, 0x47, 0xa9, 0x95, 0xc3, 0xef,
	0xd2, 0x7e, 0x87, 0x71, 0xe5, 0x69, 0x7c, 0x14, 0xdf, 0xc1, 0x84, 0xc1, 0x37, 0xc0, 0x27, 0x30,
	0x57, 0x7a, 0x44, 0x8d, 0x03, 0x4c, 0x77, 0xcd, 0xf7, 0xfb, 0xff, 0xbf, 0xf4, 0x57, 0x72, 0x25,
	0x15, 0x3e, 0x66, 0x43, 0x1a, 0xc3, 0x94, 0x19, 0x48, 0xe0, 0x5c, 0x01, 0x93, 0x09, 0x00, 0x4b,
	0x35, 0x3c, 0x89, 0x18, 0x0d, 0x93, 0x1c, 0xc5, 0x0b, 0x7f, 0x65, 0x3c, 0x55, 0x6c, 0xd6, 0x66,
	0x1a, 0x32, 0x14, 0x03, 0xe4, 0xc3, 0x44, 0xd0, 0x54, 0x03, 0x42, 0x78, 0xec, 0x08, 0x9a, 0xe7,
	0xa9, 0x82, 0x5a, 0x59, 0x82, 0x04, 0x3b, 0x63, 0xf9, 0xdf, 0x0a, 0xab, 0xb5, 0xff, 0xd9, 0x64,
	0xbf, 0x13, 0x85, 0x45, 0xf9, 0x54, 0x20, 0x1f, 0x71, 0xe4, 0x2e, 0xc2, 0x36, 0x88, 0x18, 0xe4,
	0x98, 0x99, 0x2d, 0x76, 0x14, 0x67, 0x17, 0xb9, 0xde, 0x56, 0xc0, 0x4c, 0x69, 0xcc, 0x78, 0x32,
	0x30, 0x42, 0xcf, 0x54, 0xec, 0x24, 0x34, 0x3f, 0x3c, 0x42, 0xa2, 0x5c, 0xcd, 0x7d, 0x6e, 0x26,
	0xa4, 0x24, 0xb0, 0xa2, 0x4c, 0xd5, 0x6b, 0xec, 0xb5, 0x4a, 0x9d, 0x0a, 0xfd, 0x23, 0x89, 0x5a,
	0x38, 0x72, 0x54, 0x78, 0x43, 0x82, 0xd5, 0x45, 0xaa, 0x41, 0xc3, 0x6b, 0x95, 0x3a, 0x65, 0x1a,
	0x83, 0x16, 0x6b, 0xf8, 0xce, 0xce, 0xfa, 0xa7, 0xef, 0x8b, 0xfa, 0xce, 0xd7, 0xa2, 0x7e, 0x82,
	0xc2, 0xe0, 0x48, 0x8d, 0xc7, 0xbd, 0xa6, 0x92, 0xcf, 0xa0, 0x45, 0x33, 0x72, 0xf1, 0xf0, 0x82,
	0x1c, 0x14, 0x12, 0xab, 0xfb, 0xb6, 0xaa, 0xf2, 0xbb, 0xea, 0xd6, 0x4d, 0xfb, 0x7e, 0x5e, 0x16,
	0xad, 0xe9, 0x5e, 0x6d, 0xbe, 0xf4, 0x7d, 0xb2, 0xab, 0x71, 0xbe, 0xf4, 0x8f, 0xc2, 0xc3, 0x1f,
	0xef, 0x6c, 0xfa, 0x97, 0x6f, 0x9f, 0x67, 0xde, 0x43, 0x77, 0x63, 0x55, 0xe9, 0x44, 0x3a, 0x5d,
	0xc3, 0xc0, 0xfa, 0xe9, 0x7e, 0x07, 0x00, 0x00, 0xff, 0xff, 0x88, 0x7c, 0xf2, 0x57, 0x69, 0x02,
	0x00, 0x00,
}

func (this *RouteTable) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*RouteTable)
	if !ok {
		that2, ok := that.(RouteTable)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if len(this.Routes) != len(that1.Routes) {
		return false
	}
	for i := range this.Routes {
		if !this.Routes[i].Equal(that1.Routes[i]) {
			return false
		}
	}
	if !this.Status.Equal(&that1.Status) {
		return false
	}
	if !this.Metadata.Equal(&that1.Metadata) {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
