// Code generated by solo-kit. DO NOT EDIT.

package v1

import (
	"github.com/solo-io/go-utils/contextutils"
	"github.com/solo-io/solo-kit/pkg/api/v1/clients"
	"github.com/solo-io/solo-kit/pkg/api/v1/reconcile"
	"github.com/solo-io/solo-kit/pkg/api/v1/resources"
)

// Option to copy anything from the original to the desired before writing. Return value of false means don't update
type TransitionRouteTableFunc func(original, desired *RouteTable) (bool, error)

type RouteTableReconciler interface {
	Reconcile(namespace string, desiredResources RouteTableList, transition TransitionRouteTableFunc, opts clients.ListOpts) error
}

func routeTablesToResources(list RouteTableList) resources.ResourceList {
	var resourceList resources.ResourceList
	for _, routeTable := range list {
		resourceList = append(resourceList, routeTable)
	}
	return resourceList
}

func NewRouteTableReconciler(client RouteTableClient) RouteTableReconciler {
	return &routeTableReconciler{
		base: reconcile.NewReconciler(client.BaseClient()),
	}
}

type routeTableReconciler struct {
	base reconcile.Reconciler
}

func (r *routeTableReconciler) Reconcile(namespace string, desiredResources RouteTableList, transition TransitionRouteTableFunc, opts clients.ListOpts) error {
	opts = opts.WithDefaults()
	opts.Ctx = contextutils.WithLogger(opts.Ctx, "routeTable_reconciler")
	var transitionResources reconcile.TransitionResourcesFunc
	if transition != nil {
		transitionResources = func(original, desired resources.Resource) (bool, error) {
			return transition(original.(*RouteTable), desired.(*RouteTable))
		}
	}
	return r.base.Reconcile(namespace, routeTablesToResources(desiredResources), transitionResources, opts)
}
