// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: github.com/solo-io/gloo/projects/gloo/api/v1/plugins/shadowing/shadowing.proto

package shadowing

import (
	bytes "bytes"
	fmt "fmt"
	math "math"

	_ "github.com/gogo/protobuf/gogoproto"
	proto "github.com/gogo/protobuf/proto"
	_ "github.com/gogo/protobuf/types"
	core "github.com/solo-io/solo-kit/pkg/api/v1/resources/core"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.GoGoProtoPackageIsVersion3 // please upgrade the proto package

// Specifies traffic shadowing configuration for the associated route.
// If set, Envoy will send a portion of the route's traffic to the shadowed upstream. This can be a useful way to
// preview a new service's behavior before putting the service in the critical path.
// Note that this plugin is only applicable to routes with upstream destinations (not redirect or direct response routes).
// See here for additional information on Envoy's shadowing capabilities: https://www.envoyproxy.io/docs/envoy/latest/api-v2/api/v2/route/route.proto#envoy-api-msg-route-routeaction-requestmirrorpolicy
type RouteShadowing struct {
	// The upstream to which the shadowed traffic should be sent.
	Upstream *core.ResourceRef `protobuf:"bytes,1,opt,name=upstream,proto3" json:"upstream,omitempty"`
	// This should be a value between 0.0 and 100.0, with up to 6 significant digits.
	Percentage           float32  `protobuf:"fixed32,2,opt,name=percentage,proto3" json:"percentage,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *RouteShadowing) Reset()         { *m = RouteShadowing{} }
func (m *RouteShadowing) String() string { return proto.CompactTextString(m) }
func (*RouteShadowing) ProtoMessage()    {}
func (*RouteShadowing) Descriptor() ([]byte, []int) {
	return fileDescriptor_0db98eecee20047e, []int{0}
}
func (m *RouteShadowing) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_RouteShadowing.Unmarshal(m, b)
}
func (m *RouteShadowing) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_RouteShadowing.Marshal(b, m, deterministic)
}
func (m *RouteShadowing) XXX_Merge(src proto.Message) {
	xxx_messageInfo_RouteShadowing.Merge(m, src)
}
func (m *RouteShadowing) XXX_Size() int {
	return xxx_messageInfo_RouteShadowing.Size(m)
}
func (m *RouteShadowing) XXX_DiscardUnknown() {
	xxx_messageInfo_RouteShadowing.DiscardUnknown(m)
}

var xxx_messageInfo_RouteShadowing proto.InternalMessageInfo

func (m *RouteShadowing) GetUpstream() *core.ResourceRef {
	if m != nil {
		return m.Upstream
	}
	return nil
}

func (m *RouteShadowing) GetPercentage() float32 {
	if m != nil {
		return m.Percentage
	}
	return 0
}

func init() {
	proto.RegisterType((*RouteShadowing)(nil), "shadowing.plugins.gloo.solo.io.RouteShadowing")
}

func init() {
	proto.RegisterFile("github.com/solo-io/gloo/projects/gloo/api/v1/plugins/shadowing/shadowing.proto", fileDescriptor_0db98eecee20047e)
}

var fileDescriptor_0db98eecee20047e = []byte{
	// 257 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x8c, 0x90, 0xbf, 0x4e, 0xfb, 0x30,
	0x10, 0xc7, 0x95, 0x0e, 0x3f, 0xfd, 0x14, 0x24, 0x86, 0x88, 0xa1, 0x74, 0x88, 0x2a, 0xa6, 0x0e,
	0x60, 0x0b, 0x10, 0x2f, 0xd0, 0x89, 0x89, 0x21, 0x6c, 0x6c, 0x8e, 0x7b, 0xb9, 0x9a, 0xa6, 0xf9,
	0x5a, 0x67, 0x9b, 0xbe, 0x12, 0xcf, 0xc5, 0x93, 0xa0, 0x24, 0x04, 0x3a, 0x50, 0x89, 0xc9, 0xf7,
	0xe7, 0xe3, 0xd3, 0xe7, 0x2e, 0x7f, 0x62, 0x17, 0xb7, 0xa9, 0x56, 0x16, 0x7b, 0x1d, 0xd0, 0xe2,
	0xc6, 0x41, 0x73, 0x0b, 0x68, 0x2f, 0x78, 0x25, 0x1b, 0xc3, 0x98, 0x19, 0xef, 0xf4, 0xdb, 0xad,
	0xf6, 0x6d, 0x62, 0xd7, 0x05, 0x1d, 0xb6, 0x66, 0x83, 0x83, 0xeb, 0xf8, 0x27, 0x52, 0x5e, 0x10,
	0x51, 0x94, 0x47, 0x85, 0x11, 0x56, 0xfd, 0x00, 0xd5, 0xcf, 0x56, 0x0e, 0x8b, 0x0b, 0x06, 0x63,
	0x40, 0x75, 0x1f, 0x8d, 0xbf, 0x16, 0x25, 0x03, 0xdc, 0x92, 0x1e, 0xb2, 0x3a, 0x35, 0xfa, 0x20,
	0xc6, 0x7b, 0x92, 0x70, 0xaa, 0xbf, 0x49, 0x62, 0xa2, 0x43, 0xf7, 0xd5, 0xbf, 0xfe, 0x65, 0x8b,
	0xe1, 0xdd, 0xb9, 0x38, 0xb9, 0x0b, 0x35, 0x23, 0x7d, 0xc5, 0xf9, 0x79, 0x85, 0x14, 0xe9, 0x79,
	0x52, 0x2d, 0x1e, 0xf2, 0xff, 0xc9, 0x87, 0x28, 0x64, 0xf6, 0xf3, 0x6c, 0x99, 0xad, 0xce, 0xee,
	0x2e, 0x95, 0x85, 0xd0, 0xa4, 0xad, 0x2a, 0x0a, 0x48, 0x62, 0xa9, 0xa2, 0xa6, 0xfa, 0x46, 0x8b,
	0x32, 0xcf, 0x3d, 0x89, 0xa5, 0x2e, 0x1a, 0xa6, 0xf9, 0x6c, 0x99, 0xad, 0x66, 0xd5, 0x51, 0x65,
	0xfd, 0xf8, 0xfe, 0x51, 0x66, 0x2f, 0xeb, 0xbf, 0x9d, 0xd8, 0xef, 0xf8, 0xe4, 0x99, 0xeb, 0x7f,
	0x83, 0xf9, 0xfd, 0x67, 0x00, 0x00, 0x00, 0xff, 0xff, 0x2b, 0x32, 0xca, 0xa3, 0xaf, 0x01, 0x00,
	0x00,
}

func (this *RouteShadowing) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*RouteShadowing)
	if !ok {
		that2, ok := that.(RouteShadowing)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.Upstream.Equal(that1.Upstream) {
		return false
	}
	if this.Percentage != that1.Percentage {
		return false
	}
	if !bytes.Equal(this.XXX_unrecognized, that1.XXX_unrecognized) {
		return false
	}
	return true
}
