// Code generated by solo-kit. DO NOT EDIT.

package kubernetes

import (
	"github.com/solo-io/go-utils/contextutils"
	"github.com/solo-io/solo-kit/pkg/api/v1/clients"
	"github.com/solo-io/solo-kit/pkg/api/v1/reconcile"
	"github.com/solo-io/solo-kit/pkg/api/v1/resources"
)

// Option to copy anything from the original to the desired before writing. Return value of false means don't update
type TransitionConfigMapFunc func(original, desired *ConfigMap) (bool, error)

type ConfigMapReconciler interface {
	Reconcile(namespace string, desiredResources ConfigMapList, transition TransitionConfigMapFunc, opts clients.ListOpts) error
}

func configMapsToResources(list ConfigMapList) resources.ResourceList {
	var resourceList resources.ResourceList
	for _, configMap := range list {
		resourceList = append(resourceList, configMap)
	}
	return resourceList
}

func NewConfigMapReconciler(client ConfigMapClient) ConfigMapReconciler {
	return &configMapReconciler{
		base: reconcile.NewReconciler(client.BaseClient()),
	}
}

type configMapReconciler struct {
	base reconcile.Reconciler
}

func (r *configMapReconciler) Reconcile(namespace string, desiredResources ConfigMapList, transition TransitionConfigMapFunc, opts clients.ListOpts) error {
	opts = opts.WithDefaults()
	opts.Ctx = contextutils.WithLogger(opts.Ctx, "configMap_reconciler")
	var transitionResources reconcile.TransitionResourcesFunc
	if transition != nil {
		transitionResources = func(original, desired resources.Resource) (bool, error) {
			return transition(original.(*ConfigMap), desired.(*ConfigMap))
		}
	}
	return r.base.Reconcile(namespace, configMapsToResources(desiredResources), transitionResources, opts)
}
